-module(rumMsg).

-include("rumDef.hrl").
-include("rumMsg.hrl").

-export([new/4, new/5]).
-export([message/1]).
-export([timestamp/1]).
-export([datetime/1]).
-export([severity/1]).
-export([severity_as_int/1]).
-export([metadata/1]).
-export([destinations/1]).


%% create with provided timestamp, handy for testing mostly
new(Msg, MsTick, Severity, Metadata, Destinations) ->
   TimeBinStr = rumUtil:msToBinStr(MsTick),
   #rumMsg{message = Msg, datetime = TimeBinStr, timestamp = MsTick, severity = Severity,
      metadata = Metadata, destinations = Destinations}.

new(Msg, Severity, Metadata, Destinations) ->
   NowMs = rumUtil:nowMs(),
   new(Msg, NowMs, Severity, Metadata, Destinations).

message(Msg) ->
   Msg#rumMsg.message.

timestamp(Msg) ->
   Msg#rumMsg.timestamp.

datetime(Msg) ->
   Msg#rumMsg.datetime.

severity(Msg) ->
   Msg#rumMsg.severity.

severity_as_int(Msg) ->
   rumUtil:levelToNum(Msg#rumMsg.severity).

metadata(Msg) ->
   Msg#rumMsg.metadata.

destinations(Msg) ->
   Msg#rumMsg.destinations.


